import sys
#from pystring import clean
from IoNode import IoNode
from dataModel import Integer
#===============================================================================

class Program_StdIn(IoNode):

#===============================================================================

    N=Integer(default=1)

    #----------------------------------------------------------------
    def onStart(self):
        self.i=0

    #----------------------------------------------------------------
    def onDo(self):

        self.i=0
        while self.is_running() and self.i < self.n:
            line=sys.stdin.readline().replace("\n","")
            self.send_to_pipe(data=line,data_type="text")
            self.i+=1

    #----------------------------------------------------------------


#===============================================================================

class Program_StdOut(IoNode):

#===============================================================================
    #----------------------------------------------------------------
    def onReceiveMessage(self,message):
        sys.stdout.write("%s\n"%str(message.data))
        sys.stdout.flush()

    #----------------------------------------------------------------
#===============================================================================

class Program_StdErr(IoNode):

#===============================================================================
    #----------------------------------------------------------------
    def onReceiveMessage(self,message):
        sys.stderr.write("%s\n"%str(message.data))
        sys.stderr.flush()

    #----------------------------------------------------------------

#===============================================================================


